<template>
    <fullscreen :fullscreen.sync="fullscreen" class="container">
        <div class="container-box">
            <toolList @iconCli='iconCli' :tooltit='tooltit'></toolList>
            <div class="search">
                <mySearch :searchList="searchList" @searchInfo="searchInfo"></mySearch>
                <el-button class="btn-check" size="medium" type="primary" @click="dialogCheck(3)">添加
                </el-button>
            </div>
            <div class="tabbox">
                <el-table height="calc(100% - 40px)" class="com-table" ref="multipleTable" :data="tableData"
                    tooltip-effect="dark" size="small" border style="width: 100%" v-loading="loading">
                    <el-table-column prop="budgetSum" label="预算总额">
                    </el-table-column>
                    <el-table-column prop="frameSum" label="框架总额">
                    </el-table-column>
                    <el-table-column prop="surplusSum" label="剩余总额">
                    </el-table-column>
			<!-- 		<el-table-column prop="useSum" label="剩余总额">
                    </el-table-column> -->
					<el-table-column prop="homeLocation" label="所属地">
                    </el-table-column>
					<el-table-column prop="startTime" label="开始时间">
                    </el-table-column>
					<el-table-column prop="endTime" label="截止时间">
					</el-table-column>
                    <el-table-column label="操作" width="160px" align="center">
                        <template slot-scope="scope">
                            <el-button size="mini" type="primary" @click="dialogCheck(1,scope.row)">查看</el-button>
                            <el-button size="mini" type="primary" @click="dialogCheck(2,scope.row)">修改</el-button>
                            <el-button size="mini" type="danger" @click="delLine(scope.row)">删除</el-button>
                        </template>
                    </el-table-column>
                </el-table>
                <el-pagination class="pageBox" @current-change="currchange" layout="prev, pager, next" background
                    :total="total">
                </el-pagination>
            </div>
        </div>

        <el-dialog :title="titname" :visible.sync="dialogStatus" width="50%" :destroy-on-close="true"
            :modal-append-to-body="false" :close-on-click-modal="false" :before-close="closedia">
            <div v-loading="loadinged">
                <el-form :model="infolist" ref="infolist" >
                    <div class="info-line">
                        <el-form-item>
                            <span>预算总额</span>
                            <el-input v-model="infolist.budgetSum" placeholder="预算总额" :disabled="disableStatus"></el-input>
                        </el-form-item>
                       <el-form-item>
                            <span>框架总额</span>
                            <el-input v-model="infolist.frameSum" placeholder="框架总额" :disabled="disableStatus"></el-input>
                        </el-form-item>
						<el-form-item>
                            <span>剩余总额</span>
                            <el-input v-model="infolist.surplusSum" placeholder="剩余总额" :disabled="disableStatus"></el-input>
                        </el-form-item>
				<!-- 		<el-form-item prop="costAccount">
						    <span>剩余总额</span>
						    <el-input v-model="infolist.useSum" placeholder="剩余总额" :disabled="disableStatus"></el-input>
						</el-form-item> -->
						<el-form-item>
                            <span>开始时间</span>
							<el-date-picker v-model="infolist.startTime" type="date" placeholder="开始时间" :disabled="disableStatus">
							</el-date-picker>
                        </el-form-item>
						<el-form-item>
						    <span>截止时间</span>
							<el-date-picker v-model="infolist.endTime" type="date" placeholder="截止时间" :disabled="disableStatus">
							</el-date-picker>
						</el-form-item>
						<el-form-item>
						    <span>所属地</span>
						    <el-input v-model="infolist.homeLocation" placeholder="所属地" disabled></el-input>
						</el-form-item>
                    </div>
                </el-form>

                <div slot="footer" class="dialog-footer myfooter">
                    <el-button type="primary" @click="dialogCli(2)" v-if="titname !== '查看'">确 定</el-button>
                    <el-button @click="dialogCli(1)" v-if="titname === '查看'">确 定</el-button>
                    <el-button @click="dialogCli(1)">取 消</el-button>
                </div>
            </div>
        </el-dialog>

        <myMessage :messTit='messTit' @closeMessage="closeMessage" :centerDialogVisible="centerDialogVisible" v-if="centerDialogVisible"></myMessage>
    </fullscreen>

</template>
<script>
    import mySearch from "../../../components/search.vue";
    import myMessage from "../../../components/myMessage.vue"
    import toolList from '../../../components/toolList'

    export default {
        components: {
            mySearch,
            myMessage,
            toolList
        },
        data() {
            const regionCode = (rule, value, callback) => {
                if (!this.infolist.regionCode) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
            const areaCode = (rule, value, callback) => {
                if (!this.areaCode) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
			const preAccount = (rule, value, callback) => {
                if (!this.infolist.preAccount) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
			const secbuyPreAccount = (rule, value, callback) => {
                if (!this.infolist.secbuyPreAccount) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
            return {
                rules: {
                    regionCode: [{
                        required: true,
                        trigger: 'change',
                        validator: regionCode
                    }],
                    areaCode: [{
                        required: true,
                        trigger: 'change',
                        validator: areaCode
                    }],
					preAccount: [{
                        required: true,
                        trigger: 'change',
                        validator: preAccount
                    }],
					secbuyPreAccount: [{
                        required: true,
                        trigger: 'change',
                        validator: secbuyPreAccount
                    }]
                },
                searchList: [
                    {
                        type: 'input',
                        tit: '地市名称',
                        value: '',
                        width: '98%',
                    },
                ],
                tooltit:'预算及上限',
                fullscreen: false,
                total: 0,
                pageSize: 1,
                tableData: [],
                dialogStatus: false,
                disableStatus: false,
                titname: '',
                infolist: {},
                userInfo: {},
                params: {},
                centerDialogVisible: false,
                messTit: '',
                delid: '',
                loading:false,
                loadinged:false,
				regionOpt:[],
				countyOpt:[],
				areaCode:'',
				areaName:'',
            }
        },
        methods: {
            closedia() {
                this.infolist = {};
                this.dialogStatus = false;
            },
            //搜索数据
            searchInfo(v) {
                this.params = {};
                v[0] ? this.params.regionName = v[0] : '';
                this.getList(this.params, this.pageSize);
            },
            //获取列表
            getList(v, n) {
                this.pageSize = n;
                let _this = this;
                this.loading = true;
                this.tableData = [];
                this.$http({
                    url: "/market/cAdvPubBudget/queryPage",
                    method: "post",
                    headers: {
                        "Content-Type": "application/json",
                        "page": '{"pageNo":"' + n + '","pageSize":"10"}'
                    },
                    data: v,
                }).then((res) => {
                    this.tableData = res.data.data;
                    this.total = res.data.totalRecord;
                    this.loading = false;
                });
            },
            // 分页
            currchange(v) {
                this.pageSize = v;
                this.getList(this.params, this.pageSize);
            },
            //申请
            dialogCheck(v, n) {
                this.dialogStatus = true;
                this.infolist = Object.assign({}, n);
				this.areaCode = this.infolist.areaCode;
				this.areaName = this.infolist.areaName;
                if (v === 1) {
                    this.titname = '查看';
                    this.disableStatus = true;
					this.getComp(v.regionCode);
                    return
                } else if (v === 2) {
                    this.titname = '修改';
                    this.disableStatus = false;
					this.getComp(v.regionCode);
                } else if (v === 3) {
                    this.titname = '添加';
                    this.disableStatus = false;
                }
                this.infolist.opNo = this.userInfo.loginNo;
                this.infolist.opName = this.userInfo.loginName;
            },
            //添加
            dialogCli(v) {
                if (v === 1) {
                    this.infolist = {};
                    this.dialogStatus = false;
                    return
                } else {
                    this.infolist.opTime = this.$formatDate(new Date(), "YYYY-MM-DD");
                    this.infolist.startTime = this.infolist.startTime?this.$formatDate(this.infolist.startTime, "YYYY-MM-DD"):'';
                    this.infolist.endTime = this.infolist.endTime?this.$formatDate(this.infolist.endTime, "YYYY-MM-DD"):'';
					this.infolist.areaCode = this.areaCode;
					this.infolist.areaName = this.areaName;
                    if (this.titname === '添加') {
                        this.submitInfo("/market/cAdvPubBudget/add");
                    } else if (this.titname === '修改') {
                        this.submitInfo("/market/cAdvPubBudget/update", v);
                    }

                }
            },
            submitInfo(u) {
                let _this = this;
                this.$refs.infolist.validate(valid => {
                    if (valid) {
                        this.loadinged = true;
                        this.$http({
                            url: u,
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                            },
                            data: this.infolist,
                        }).then((res) => {
                            this.loadinged = false;
                            if (res.data.result === 1) {
                                _this.$message({
                                    message: res.data.desc,
                                    type: 'error'
                                });
                            } else {
                                _this.$message({
                                    message: '成功',
                                    type: 'success'
                                });
                                _this.infolist = {};
                                _this.dialogStatus = false;
                                _this.getList({}, _this.pageSize);
                            }

                        });
                    }
                })
            },
            closeMessage(v) {
                this.centerDialogVisible = false;
                let _this = this;
                if (v === 1) {
                    _this.$http({
                        url: "/market/cAdvPubBudget/del",
                        method: "post",
                        headers: {
                            "Content-Type": "application/json",
                        },
                        data: {
                            id: this.delid
                        },
                    }).then((res) => {
                        if (res.data.result === 1) {
                            _this.$message({
                                message: res.data.desc,
                                type: 'error'
                            });
                        } else {
                            _this.$message({
                                message: '删除成功',
                                type: 'success'
                            });
                            _this.getList(this.params, this.pageSize);
                        }
                    });
                }
            },
            //删除
            delLine(v) {
                this.centerDialogVisible = true;
                this.messTit = '即将删除此条数据, 是否删除?';
                this.delid = v.id;
            },
            //文件返回值
            uploadBack(v) {
                console.log(v)
            },
            //功能栏
            iconCli(v) {
                if (v === 1) {
                    this.getList(this.params, this.pageSize);
                }
                if (v === 2) {
                    this.fullscreen = !this.fullscreen
                }
            },
			verifcheck(v) {
				if(v == 2){
					for (let i = 0; i < this.countyOpt.length; i++) {
						if (this.countyOpt[i].compId === this.areaCode) {
							this.areaName = this.countyOpt[i].compName
						}
					}
				}else{
					for (let i = 0; i < this.regionOpt.length; i++) {
						if (this.regionOpt[i].compId === this.infolist.regionCode) {
							this.infolist.regionName = this.regionOpt[i].compName;
							this.areaCode = '';
							this.areaName = '';
							this.getComp(this.regionOpt[i].compId);
						}
					}
				}
			},
			getComp(v){
				this.$http({
					url: "/sysmgr/regionComp/queryList",
					method: "post",
					headers: {
						"Content-Type": "application/json",
					},
					data: {
						parentCompId: v
					},
				}).then((res) => {
					this.countyOpt = res.data;
				});
			},
            getUser() {
                this.userInfo = JSON.parse(window.sessionStorage.userInfo);
				this.$http({
				    url: "/sysmgr/regionComp/queryList",
				    method: "post",
				    headers: {
				        "Content-Type": "application/json",
				    },
				    data: {
				        parentCompId: '0'
				    },
				}).then((res) => {
				    this.regionOpt = res.data;
				});
            }
        },
        mounted() {
            this.getList({}, 1);
            this.getUser();
        },
        created() {

        }
    }
</script>
<style scoped lang="scss">
    .onetab {
        margin-bottom: 20px;
        padding: 0 20px;
    }

    .titbox {
        div {
            float: right;

            i {
                font-size: 22px;
                margin-left: 20px;
                cursor: pointer;
            }
        }
    }

    .tabbox {
        margin-top: 15px;
    }

    .pageBox {
        text-align: right;
        margin-top: 10px;
    }

    .info-line {
        width: 100%;
        display: block;
        padding-left: 20px;

        div {
            width: 50%;
            display: inline-block;
        }

        span {
            width: 80px;
            display: inline-block;
            text-align: left;

            i {
                color: red;
                display: inline-block;
                padding-right: 5px;
            }
        }

        .el-select,
        .el-input {
            width: calc(100% - 100px);
        }
    }

    .online {
        width: 100%;

        .el-select {
            width: calc(100% - 100px);
        }

        span {
            vertical-align: top;
        }

        .el-textarea {
            width: calc(100% - 100px);
        }
    }
</style>
